<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/Entity.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Entity.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Entity_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef Entity_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define Entity_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="GameObject_8h.html">GameObject.h</a>&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">class </span><a class="code" href="classWeapon.html">Weapon</a>;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="classEntity.html">   10</a></span>&#160;<span class="keyword">class </span><a class="code" href="classEntity.html">Entity</a> : <span class="keyword">public</span> <a class="code" href="classGameObject.html">GameObject</a>{</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <a class="code" href="classEntity.html#adf6d3f7cb1b2ba029b6b048a395cc8ae">~Entity</a>();</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEntity.html#a990ba22de82974bcfad77f68cb74ea7e">Damage</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; dmg) = 0;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classEntity.html#a665dc0ca1dc7018e36645156848d9397">SetHealth</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; health);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classEntity.html#ae1d1d591b332c37c5fab7d8ce60acfc0">GetHealth</a>();</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEntity.html#a91cd0f86409513098d548228466eb6d7">SetupStats</a>() = 0;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEntity.html#ab04e6b564dfedd4641e8df53970e1fbf">InitWeapon</a>() = 0;</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classEntity.html#aa4cb7571a862fe9c5170dce0845b8d0b">   38</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classEntity.html#aa4cb7571a862fe9c5170dce0845b8d0b">m_Health</a>;</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classEntity.html#a636d319a245a619c34290aafe061db7f">   39</a></span>&#160;    <a class="code" href="classWeapon.html">Weapon</a> * <a class="code" href="classEntity.html#a636d319a245a619c34290aafe061db7f">m_Weapon</a>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;};</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* Entity_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassWeapon_html"><div class="ttname"><a href="classWeapon.html">Weapon</a></div><div class="ttdoc">Factory styled class for creating projectiles.</div><div class="ttdef"><b>Definition:</b> Weapon.h:12</div></div>
<div class="ttc" id="aclassGameObject_html"><div class="ttname"><a href="classGameObject.html">GameObject</a></div><div class="ttdoc">Abstract class that represents GameObject with collision and movement properties.</div><div class="ttdef"><b>Definition:</b> GameObject.h:14</div></div>
<div class="ttc" id="aclassEntity_html_ae1d1d591b332c37c5fab7d8ce60acfc0"><div class="ttname"><a href="classEntity.html#ae1d1d591b332c37c5fab7d8ce60acfc0">Entity::GetHealth</a></div><div class="ttdeci">int GetHealth()</div><div class="ttdef"><b>Definition:</b> Entity.cpp:14</div></div>
<div class="ttc" id="aclassEntity_html_aa4cb7571a862fe9c5170dce0845b8d0b"><div class="ttname"><a href="classEntity.html#aa4cb7571a862fe9c5170dce0845b8d0b">Entity::m_Health</a></div><div class="ttdeci">int m_Health</div><div class="ttdef"><b>Definition:</b> Entity.h:38</div></div>
<div class="ttc" id="aclassEntity_html_a636d319a245a619c34290aafe061db7f"><div class="ttname"><a href="classEntity.html#a636d319a245a619c34290aafe061db7f">Entity::m_Weapon</a></div><div class="ttdeci">Weapon * m_Weapon</div><div class="ttdef"><b>Definition:</b> Entity.h:39</div></div>
<div class="ttc" id="aclassEntity_html_a990ba22de82974bcfad77f68cb74ea7e"><div class="ttname"><a href="classEntity.html#a990ba22de82974bcfad77f68cb74ea7e">Entity::Damage</a></div><div class="ttdeci">virtual void Damage(const int &amp;dmg)=0</div><div class="ttdoc">Deals damage to self.</div></div>
<div class="ttc" id="aclassEntity_html"><div class="ttname"><a href="classEntity.html">Entity</a></div><div class="ttdoc">Abstract class representing GameObjects that have weapon and health.</div><div class="ttdef"><b>Definition:</b> Entity.h:10</div></div>
<div class="ttc" id="aclassEntity_html_a91cd0f86409513098d548228466eb6d7"><div class="ttname"><a href="classEntity.html#a91cd0f86409513098d548228466eb6d7">Entity::SetupStats</a></div><div class="ttdeci">virtual void SetupStats()=0</div><div class="ttdoc">Pure virtual function for setring up variables.</div></div>
<div class="ttc" id="aclassEntity_html_a665dc0ca1dc7018e36645156848d9397"><div class="ttname"><a href="classEntity.html#a665dc0ca1dc7018e36645156848d9397">Entity::SetHealth</a></div><div class="ttdeci">void SetHealth(const int &amp;health)</div><div class="ttdef"><b>Definition:</b> Entity.cpp:10</div></div>
<div class="ttc" id="aclassEntity_html_adf6d3f7cb1b2ba029b6b048a395cc8ae"><div class="ttname"><a href="classEntity.html#adf6d3f7cb1b2ba029b6b048a395cc8ae">Entity::~Entity</a></div><div class="ttdeci">~Entity()</div><div class="ttdoc">Destroy the Entity object and deletes allocated weapon.</div><div class="ttdef"><b>Definition:</b> Entity.cpp:3</div></div>
<div class="ttc" id="aGameObject_8h_html"><div class="ttname"><a href="GameObject_8h.html">GameObject.h</a></div></div>
<div class="ttc" id="aclassEntity_html_ab04e6b564dfedd4641e8df53970e1fbf"><div class="ttname"><a href="classEntity.html#ab04e6b564dfedd4641e8df53970e1fbf">Entity::InitWeapon</a></div><div class="ttdeci">virtual void InitWeapon()=0</div><div class="ttdoc">Pure virtual function for initializing weapon.</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
